
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【翻译】PHP7——新特性 / iVAN</title>

    <meta name="description" content="【翻译】PHP7——新特性 原文地址: http://php.net/manual/zh/migration70.new-features.php 新特性 标量类型声明 标量类型声明 有两种模式: 强制 (默认) 和 严格模式. 现在可以使用下列类型参数(无论用强制模式还是严格模式): 字符串(string), 整数 (int), 浮点数 (float), 以及布尔值 (bool).它们扩充了PHP5中引入的其他类型:类名,接口,数组和 回调类型 &lt;?php // Coercive mode function sum ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">【翻译】PHP7——新特性</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><em>原文地址: <a href="http://php.net/manual/zh/migration70.new-features.php" rel="external nofollow noreferrer">http://php.net/manual/zh/migration70.new-features.php</a></em></p>
<h1>新特性</h1>
<h2>标量类型声明</h2>
<p>标量类型声明 有两种模式: 强制 (默认) 和 严格模式。 现在可以使用下列类型参数（无论用强制模式还是严格模式）： 字符串(string), 整数 (int), 浮点数 (float), 以及布尔值 (bool)。它们扩充了PHP5中引入的其他类型：类名，接口，数组和 回调类型</p>
<pre><code>&lt;?php
// Coercive mode
function sumOfInts(int ...$ints)
{
    return array_sum($ints);
}

var_dump(sumOfInts(2, '3', 4.1));</code></pre>
<p>以上例程会输出：</p>
<pre><code>int(9)</code></pre>
<p>要使用严格模式，一个 declare 声明指令必须放在文件的顶部。这意味着严格声明标量是基于文件可配的。 这个指令不仅影响参数的类型声明，也影响到函数的返回值声明（参见 返回值类型声明, 内置的PHP函数以及扩展中加载的PHP函数）</p>
<p>完整的标量类型声明文档和示例参见类型声明章节。</p>
<h2>返回值类型声明</h2>
<p>PHP 7 增加了对返回类型声明的支持。 类似于参数类型声明，返回类型声明指明了函数返回值的类型。可用的类型与参数声明中可用的类型相同。</p>
<pre><code>&lt;?php

function arraysSum(array ...$arrays): array
{
    return array_map(function(array $array): int {
        return array_sum($array);
    }, $arrays);
}

print_r(arraysSum([1,2,3], [4,5,6], [7,8,9]));</code></pre>
<p>以上例程会输出：</p>
<pre><code>Array
(
    [0] =&gt; 6
    [1] =&gt; 15
    [2] =&gt; 24
)</code></pre>
<p>完整的标量类型声明文档和示例可参见 返回值类型声明.</p>
<h2>null合并运算符</h2>
<p>由于日常使用中存在大量同时使用三元表达式和 isset()的情况， 我们添加了null合并运算符 (??) 这个语法糖。如果变量存在且值不为NULL， 它就会返回自身的值，否则返回它的第二个操作数。</p>
<pre><code>&lt;?php
// Fetches the value of $_GET['user'] and returns 'nobody'
// if it does not exist.
$username = $_GET['user'] ?? 'nobody';
// This is equivalent to:
$username = isset($_GET['user']) ? $_GET['user'] : 'nobody';

// Coalesces can be chained: this will return the first
// defined value out of $_GET['user'], $_POST['user'], and
// 'nobody'.
$username = $_GET['user'] ?? $_POST['user'] ?? 'nobody';
?&gt;</code></pre>
<h2>太空船操作符（组合比较符）</h2>
<p>太空船操作符用于比较两个表达式。当a大于、等于或小于b时它分别返回-1、0或1。 比较的原则是沿用 PHP 的常规比较规则进行的。</p>
<pre><code>&lt;?php
// Integers
echo 1 &lt;=&gt; 1; // 0
echo 1 &lt;=&gt; 2; // -1
echo 2 &lt;=&gt; 1; // 1

// Floats
echo 1.5 &lt;=&gt; 1.5; // 0
echo 1.5 &lt;=&gt; 2.5; // -1
echo 2.5 &lt;=&gt; 1.5; // 1

// Strings
echo "a" &lt;=&gt; "a"; // 0
echo "a" &lt;=&gt; "b"; // -1
echo "b" &lt;=&gt; "a"; // 1
?&gt;</code></pre>
<h2>通过 define() 定义常量数组</h2>
<p>Array 类型的常量现在可以通过 definedefine() 来定义。在 PHP5.6 中仅能通过 const 定义。</p>
<pre><code>&lt;?php
define('ANIMALS', [
    'dog',
    'cat',
    'bird'
]);

echo ANIMALS[1]; // outputs "cat"
?&gt;</code></pre>
<h2>匿名类</h2>
<p>现在支持通过new class 来实例化一个匿名类，这可以用来替代一些“用后即焚”的完整类定义</p>
<pre><code>&lt;?php
interface Logger {
    public function log(string $msg);
}

class Application {
    private $logger;

    public function getLogger(): Logger {
         return $this-&gt;logger;
    }

    public function setLogger(Logger $logger) {
         $this-&gt;logger = $logger;
    }
}

$app = new Application;
$app-&gt;setLogger(new class implements Logger {
    public function log(string $msg) {
        echo $msg;
    }
});

var_dump($app-&gt;getLogger());
?&gt;</code></pre>
<p>以上例程会输出：</p>
<pre><code>object(class@anonymous)#2 (0) {
}</code></pre>
<p>详细文档可以参考 匿名类.</p>
<h2>Unicode codepoint 转译语法</h2>
<p>这接受一个以16进制形式的 Unicode codepoint，并打印出一个双引号或heredoc包围的 UTF-8 编码格式的字符串。 可以接受任何有效的 codepoint，并且开头的 0 是可以省略的。</p>
<pre><code>echo "\u{aa}";
echo "\u{0000aa}";
echo "\u{9999}";</code></pre>
<p>以上例程会输出：</p>
<pre><code>ª
ª (same as before but with optional leading 0's)
香</code></pre>
<h2>Closure::call()</h2>
<p>Closure::call() 现在有着更好的性能，简短干练的暂时绑定一个方法到对象上闭包并调用它。</p>
<pre><code>&lt;?php
class A {private $x = 1;}

// Pre PHP 7 code
$getXCB = function() {return $this-&gt;x;};
$getX = $getXCB-&gt;bindTo(new A, 'A'); // intermediate closure
echo $getX();

// PHP 7+ code
$getX = function() {return $this-&gt;x;};
echo $getX-&gt;call(new A);</code></pre>
<p>以上例程会输出：</p>
<pre><code>1
1</code></pre>
<h2>为unserialize()提供过滤</h2>
<p>这个特性旨在提供更安全的方式解包不可靠的数据。它通过白名单的方式来防止潜在的代码注入。</p>
<pre><code>&lt;?php

// converts all objects into __PHP_Incomplete_Class object
$data = unserialize($foo, ["allowed_classes" =&gt; false]);

// converts all objects into __PHP_Incomplete_Class object except those of MyClass and MyClass2
$data = unserialize($foo, ["allowed_classes" =&gt; ["MyClass", "MyClass2"]);

// default behaviour (same as omitting the second argument) that accepts all classes
$data = unserialize($foo, ["allowed_classes" =&gt; true]);</code></pre>
<h2>IntlChar</h2>
<p>新增加的 IntlChar 类旨在暴露出更多的 ICU 功能。这个类自身定义了许多静态方法用于操作多字符集的 unicode 字符。</p>
<pre><code>&lt;?php

printf('%x', IntlChar::CODEPOINT_MAX);
echo IntlChar::charName('@');
var_dump(IntlChar::ispunct('!'));</code></pre>
<p>以上例程会输出：</p>
<pre><code>10ffff
COMMERCIAL AT
bool(true)</code></pre>
<p>若要使用此类，请先安装Intl扩展</p>
<h2>预期</h2>
<p>预期是向后兼用并增强之前的 assert() 的方法。 它使得在生产环境中启用断言为零成本，并且提供当断言失败时抛出特定异常的能力。</p>
<p>老版本的API出于兼容目的将继续被维护，assert()现在是一个语言结构，它允许第一个参数是一个表达式，而不仅仅是一个待计算的 string或一个待测试的boolean。</p>
<pre><code>&lt;?php
ini_set('assert.exception', 1);

class CustomError extends AssertionError {}

assert(false, new CustomError('Some error message'));
?&gt;</code></pre>
<p>以上例程会输出：</p>
<pre><code>Fatal error: Uncaught CustomError: Some error message</code></pre>
<p>关于这个特性的完整说明，包括如何在开发和生产环境中配置它，可以在assert()的 expectations section章节找到。</p>
<h2>Group use declarations</h2>
<p>从同一 namespace 导入的类、函数和常量现在可以通过单个 use 语句 一次性导入了。</p>
<pre><code>&lt;?php

// Pre PHP 7 code
use some\namespace\ClassA;
use some\namespace\ClassB;
use some\namespace\ClassC as C;

use function some\namespace\fn_a;
use function some\namespace\fn_b;
use function some\namespace\fn_c;

use const some\namespace\ConstA;
use const some\namespace\ConstB;
use const some\namespace\ConstC;

// PHP 7+ code
use some\namespace\{ClassA, ClassB, ClassC as C};
use function some\namespace\{fn_a, fn_b, fn_c};
use const some\namespace\{ConstA, ConstB, ConstC};
?&gt;</code></pre>
<h2>Generator Return Expressions</h2>
<p>此功能是建立在引入PHP5.5发电机的功能。它能够为要在发电机内使用，以便为最终的表达式返回return语句（返回引用是不允许的）。该值可以使用新的发电机:: getReturn（）方法，该方法只能使用一次发电机已完成收益值是牵强。</p>
<pre><code>&lt;?php

$gen = (function() {
    yield 1;
    yield 2;

    return 3;
})();

foreach ($gen as $val) {
    echo $val, PHP_EOL;
}

echo $gen-&gt;getReturn(), PHP_EOL;</code></pre>
<p>以上例程会输出：</p>
<pre><code>1
2
3</code></pre>
<p>能够从发电机明确地返回一个最终值是有一个方便的能力。这是因为它使供到由发电机被返回（从或许某种形式的协程计算），可以通过执行发生器客户代码进行具体处理的最终值。这比迫使客户端代码首先检查最终值是否已经产生了，然后如果是这样，专门负责处理该值简单。</p>
<h2>Generator delegation</h2>
<p>发电机现在可以委托给另一发生器，自动位移对象或数组，而无需使用来自结构屈服编写样板在最外面的发电机。</p>
<pre><code>&lt;?php

function gen()
{
    yield 1;
    yield 2;

    yield from gen2();
}

function gen2()
{
    yield 3;
    yield 4;
}

foreach (gen() as $val)
{
    echo $val, PHP_EOL;
}

?&gt;</code></pre>
<p>以上例程会输出：</p>
<pre><code>1
2
3
4</code></pre>
<h2>Integer division with intdiv()</h2>
<p>新intdiv（）函数执行的操作数的整数除法并返回。</p>
<pre><code>&lt;?php

var_dump(intdiv(10, 3));
?&gt;</code></pre>
<p>以上例程会输出：</p>
<pre><code>int(3)</code></pre>
<h2>Session options</h2>
<p>在session_start（）现在接受的选项，覆盖在php.ini中通常设置会话配置指令的数组。</p>
<p>这些选项也得到了扩展，以支持session.lazy_write，这是在默认情况下并导致PHP只覆盖任何会话文件，如果会话数据已经改变，read_and_close，这是一个只能传递给在session_start（）的选项，以表明会话数据应该读，然后会议应立即关闭不变。</p>
<p>例如，要session.cache_limiter设置为私有，并立即阅读后关闭会话：</p>
<pre><code>&lt;?php
session_start([
    'cache_limiter' =&gt; 'private',
    'read_and_close' =&gt; true,
]);
?&gt;</code></pre>
<h2>preg_replace_callback_array()</h2>
<p>新preg_replace_callback_array（）函数使代码编写更干净使用preg_replace_callback（）函数时。在此之前PHP7，这需要每个正则表达式执行回调需要回调函数被污染，有很多分支。</p>
<p>现在，回调可以注册使用一个关联数组，其中最关键的是一个正则表达式的值是一个回调的每个正则表达式。</p>
<h2>CSPRNG Functions</h2>
<p>两个新的功能已被添加到生成加密安全整数和字符串的跨平台的方式：random_bytes（）和random_int（）。</p>
<h2>list() can always unpack objects implementing ArrayAccess</h2>
<p>此前，列表（）是不能保证与实施了ArrayAccess对象的正常运行。这已得到修复。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 13:59:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/%e6%ad%a3%e5%88%99%e8%a1%a8%e8%be%be%e5%bc%8f/" title="正则表达式">正则表达式</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>, <a href="https://www.iamivan.net/tag/logger/" title="logger">logger</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>【翻译】PHP7——新特性的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVwv1Bb.html" rel="bookmark">PHP7 新特性详细介绍&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP 的学习新特性 最近做的项目使用了 php7,但感觉有很多新特性没有用起来.就想总结一下,一些可能会用到的新特性.之前使用的环境是 php5.4,所有也会有 php5.5 和 php5.6 的特性总结进来,这里只列出我觉得在项目中可能用到的特性,主要内容来自 php手册的附录. Generators (PHP 5 &gt;= 5.5.0, PHP 7) 通过添加 yield 关键字支持了 generators,Generators 提供了一个更简单的方法实现迭代器,不需要实现 Iterator			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bojLaEz.html" rel="bookmark">PHP7新特性foreach 修改示例介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.foreach()循环对数组内部指针不再起作用,在PHP7之前,当数组通过foreach迭代时,数组指针会移动.现在开始,不再如此,见下面代码.. $array = [0, 1, 2]; foreach ($array as &amp;$val) { var_dump(current($array)); } PHP5运行的结果会打印int(1) int(2) bool(false) PHP7运行的结果会打印三次int(0),也就是说数组的内部指针并没有改变. 之前运行的结果会打印int(1), in			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZZOJz.html" rel="bookmark">PHP7 新特性新功能有哪些&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP7 就要到来,网上也散布许多零散的相关的消息,PHP7 到底都有些什么改变?我们 PHPer 又将需要做什么改变,本篇博客将尝试一一列举. PHP7 跟以前不兼容的地方 由于采纳了 AST(Abstract Syntax Tree) 以及 Uniform Variable Syntax,有些代码的意义会有变化,比如: $obj-&gt;$properties['name']   // PHP5.6里等价于 $obj-&gt;{$properties['name']}   // 但在PHP7等价于 {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxEEJPp.html" rel="bookmark">浅谈php7的重大新特性&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				截止到目前为止,PHP官方已经发布了php7的RC5版本,预计在11月份左右会发布第一个正式版本!现在来说php7的重大特性肯定已经是定型了,不会再有什么变动了.后续一些版本的迭代主要也就是修修bug,优化之类的.下面就来说话我们一直期待的php7会有那些主要的变化了... 新特性预览 ZEND引擎升级到Zend Engine 3,也就是所谓的PHP NG 增加抽象语法树,使编译更加科学 64位的INT支持 统一的变量语法 原声的TLS - 对扩展开发有意义 一致性foreach循环的改进 新增			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/dzZ0EaM.html" rel="bookmark">PHP 7 的五大新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 运算符(NULL 合并运算符) 把这个放在第一个说是因为我觉得它很有用.用法: $a = $_GET['a'] ?? 1; 它相当于: &lt;php $a = isset($_GET['a']) ? $_GET['a'] : 1; 我们知道三元运算符是可以这样用的: $a ?: 1 但是这是建立在 $a 已经定义了的前提上.新增的 ?? 运算符可以简化判断. 2. 函数返回值类型声明 官方文档提供的例子(注意 - 的边长参数语法在 PHP 5.6 以上的版本中才有): &lt;php  funct			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmB2ABz.html" rel="bookmark">PHP 7的一些引人注目的新特性简单介绍&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. ?? 运算符(NULL 合并运算符)把这个放在第一个说是因为我觉得它很有用.用法: $a = $_GET['a'] ?? 1; 它相当于: &lt;?php $a = isset($_GET['a']) ? $_GET['a'] : 1; 我们知道三元运算符是可以这样用的: $a ?: 1 但是这是建立在 $a 已经定义了的前提上.新增的 ?? 运算符可以简化判断. 2. 函数返回值类型声明官方文档提供的例子(注意 ... 的边长参数语法在 PHP 5.6 以上的版本中才有): &lt;?php f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYkOLxz.html" rel="bookmark">C&plus;&plus;11的新特性简单汇总介绍 &lpar;二&rpar;&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 范围for语句 C++11 引入了一种更为简单的for语句,这种for语句可以很方便的遍历容器或其他序列的所有元素 vector&lt;int&gt; vec = {1,2,3,4,5,6}; for(int x: vec) { cout&lt;&lt;x&lt;&lt;endl; } 2. 尾置返回类型 要想引入尾置类型,我们还得从复杂的类型声明说起.如果我们需要定义一个含有10个int元素的数组,一般是这样的: int arr[10] = {0}; 如果要定义指向这个数组的指针呢: 复制代码 代			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My2xjPp.html" rel="bookmark">PHP5&period;3新特性小结&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文总结分析了PHP5.3新特性.分享给大家供大家参考,具体如下: 1.命名空间 解决了类,函数和常量名冲突的问题 2.静态绑定 继承时父类可以直接调用子类重写父类的方法 class A { public static function who() { echo __CLASS__; } public static function test() { static::who(); // 后期静态绑定从这里开始 } } class B extends A { public static funct			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baar4Qb.html" rel="bookmark">C&plus;&plus;11的新特性简单汇总介绍 &lpar;一&rpar;&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是C++11 C++11是曾经被叫做C++0x,是对目前C++语言的扩展和修正,C++11不仅包含核心语言的新机能,而且扩展了C++的标准程序库(STL),并入了大部分的C++ Technical Report 1(TR1)程序库(数学的特殊函数除外). C++11包括大量的新特性:包括lambda表达式,类型推导关键字auto.decltype,和模板的大量改进. 1. 概述 最近在看C++ Primer5 刚好看到一半,总结一下C++11里面确实加了很多新东西,如果没有任何了解,别说自己			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDAn6b.html" rel="bookmark" class="title">RESTful&lowbar;URI资源</a>
					<div>
						RESTful的资源 在RESTful基础知识篇中,介绍了资源是存在于业务逻辑层中的概念实体(如:应用程序对象.数据库记录.算法.HTML.视频图像等),它会在表现层中被确定,并最终由表现层将资源向自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL81Ap.html" rel="bookmark" class="title">排名的诱惑：页面质量决定网站信用度</a>
					<div>
						网站信用度是用户体验为主后,SEOer对于最新搜索引擎算法的体验值评定.在不断对网站进行优化的过程中,笔者小丹发现网站的信用度越高,收录越好,对于每个页面的质量要求就相对较低;反之则相反. 如何来提高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVVjkz.html" rel="bookmark" class="title">推荐自己用的&lbrack;商店管家收银管理系统专业版&rsqb;</a>
					<div>
						软件介绍: 商店管家收银管理系统是专门针对POS收银.商店店主设计开发,集商品进销存.帐目管理.客户 信息于一体的店主管理软件.功能实用,操作简单! 功能实用.集于一体 提供商店管理必备的商品进销存管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwND8p.html" rel="bookmark" class="title">Java简单类型进行精确浮点数运算</a>
					<div>
						运算 由于Java的简单类型不能够精确的对浮点数进行运算,这个工具类提供精确的浮点数运算,包括加减乘除和四舍五入. 以下为代码: import java.math.BigDecimal; public ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5LLRM.html" rel="bookmark" class="title">php在页面中调用fckeditor编辑器的方法</a>
					<div>
						刚才在论坛上看到一个童鞋分享的方法,感觉不是很全面,现在分享下我的! 复制代码 代码如下: PHP页面: /* 编辑器 */ include_once &quot;../include/fckedit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w378p.html" rel="bookmark" class="title">java中final的用法</a>
					<div>
						许多程序设计语言都有自己的办法告诉编译器某个数据是&quot;常数&quot;.常数主要应用于下述两个方面: (1) 编译期常数,它永远不会改变 (2) 在运行期初始化的一个值,我们不希望它发生变化  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy8ydb.html" rel="bookmark" class="title">可循环显示图像的Android Gallery组件</a>
					<div>
						Gallery组件主要用于横向显示图像列表,不过按常规做法.Gallery组件只能有限地显示指定的图像.也就是说,如果为Gallery组件指定了10张图像,那么当Gallery组件显示到第10张时,就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPKLrz.html" rel="bookmark" class="title">利用RDA实现SQL CE与桌面SQL Server数据库间的数据存取</a>
					<div>
						本文介绍如何利用RDA(RemoteDataAccess远程数据存取)实现掌上电脑Pocket PC(简称PPC)上的SQL Server CE 2.0与桌面SQL Server 2000数据库间的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badmGQz.html" rel="bookmark" class="title">分析win7远程桌面开启失败的原因</a>
					<div>
						很多人对于远程控制的认知,还停留在QQ的远程控制里面.但是现在越来越多的人上班的时候,用一台电脑而家里还有一台电脑开着,有的时候,需要用家里的电脑控制上班用的电脑或者上班用的电脑需要控制家里的电脑.这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EvPdM.html" rel="bookmark" class="title">如何使用PDF Image Extraction Wizard提取pdf文档中jpeg图片</a>
					<div>
						如何将PDF中的jpeg和bmp图片单独的批量提取出来?很多PDF中的图片资源都是很有使用价值的,可以作为其他方面的素材.小编教你使用PDF Image Extraction Wizard提取pdf文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrJrrM.html" rel="bookmark" class="title">《Web前端开发最佳实践》&mdash;&mdash;3&period;3　正确闭合HTML标签</a>
					<div>
						3.3 正确闭合HTML标签 HTML元素的内容模型定义了元素的结构,表明元素可以包含哪些内容以及元素可以有哪些属性.元素可以包含的内容包括其他元素和字符,但是也有一些元素是空元素,即不能包含任何内容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR0BDz.html" rel="bookmark" class="title">R语言可视化之UpSetR包</a>
					<div>
						集合可视化我们用得最多的是韦恩图,韦恩图在集合数少的时候是很好用的,但是当集合数多比如五个以上的时候那就会看花眼了,比如下面这副含有6个集合韦恩图,是发表在Nature上的文章里的,漂亮是漂亮,但是眼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Ym9KM.html" rel="bookmark" class="title">联想集团涨超7&percnt; 杨元庆持股比例升至8&period;12&percnt;</a>
					<div>
						7月18日消息 联想集团今早开盘后一路上扬,截止13:18分,联想集团(5.06, 0.32, 6.75%)涨7.173%,报5.08港元,成交额5.909亿. 据悉,杨元庆耗资9340万元分别于7月 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My38eZz.html" rel="bookmark" class="title">Struts Spring Hibernate &lpar;SSH&rpar; 整合实例</a>
					<div>
						首选创建web.xml 主要是配置Struts的ActionServlet和Spring的字符过滤器 &lt;?xml version=&quot;1.0&quot; encoding=&quot;U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNYWmz.html" rel="bookmark" class="title">下面的代码为什么出错？该怎么去改？数据库中设置的允许为NULL，但不输入值时为什么会报错？</a>
					<div>
						问题描述 下面的代码为什么出错?该怎么去改?数据库中设置的允许为NULL,但不输入值时为什么会报错? 解决方案 看下output窗格输出的错误提示,你的empAge是什么类型?是int?还是int,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7gV8M.html" rel="bookmark" class="title">以实践为起点，设计出重基础的学习之路</a>
					<div>
						在CSDN对我的专访中,我比较全面地阐述了我带领学生开展的以实践为主线的编程学习过程.有人发表评论:&quot;如果你是大学生,我建议你把这篇文章当成垃圾看.大学重点学得应该是基础,不是你那些所谓的为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe42Xb.html" rel="bookmark" class="title">百度股价大涨的三宗最</a>
					<div>
						文/互联网说 隔夜惊喜不断,百度在今天凌晨开盘后股价一路稳步上涨,截至收盘,百度股价大涨10.88%,报收226.5美元,再创52周新高.过去52周,百度股价从124.27美元一路飙升,最高为今日盘中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXgymz.html" rel="bookmark" class="title">IIS日志报Connections&lowbar;Refused问题的解决方法&lowbar;win服务器</a>
					<div>
						文件位置:C:\WINDOWS\system32\LogFiles\HTTPERR\httperr1.log 一.问题描述 以前一直正常的ASP网站今天出现了打不开的情况,网站是部署在IIS下的.通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydqBvb.html" rel="bookmark" class="title">Linux&colon;centos释放缓存&comma;查看磁盘空间大小&comma;xxx文件夹， 查看文件夹大小&comma;查看剩余内存&comma;查看xxx软件位置&comma;统计某文件夹&comma;统计某文件夹下目录数量&comma;查看文件夹大小，给文件夹下所有的文件赋值权限</a>
					<div>
						一台老的PHP后台服务器,今天用 free -m 查看,发现内存跑满了. 再 top,然后按下shift+m,也就是按内存占用百分比排序,发现排在第一的进程,才占用0.9%,那是什么占用的呢?谷歌了一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmQ73M.html" rel="bookmark" class="title">GoogleAdWords关键字广告：不同排名位置的点击率比较</a>
					<div>
						之前我们看了国外主要搜索引擎的广告点击率数据,那么Google AdWords关键字广告在不同排名位置上的点击率是怎么样的呢? 对此,国外的一家研究机构给出了一张折线图,这张图的横轴是各个广告位的序号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNNqkM.html" rel="bookmark" class="title">NoSql数据库初探-mongoDB环境搭建</a>
					<div>
						NoSQL数据库一改关系型数据库的缺点,更容易的集成.分布式.无模式.故障恢复等特点,正在一步步餐食关系型数据库的市场,作为一个与时俱进的码农了解一下新技术是必须的,尤其是在读了&lt;NoSql精粹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZKPop.html" rel="bookmark" class="title">高度可视化的大数据吸引高层眼球</a>
					<div>
						大数据对CEO们是炙手可热的,这对数据管理专家们来说这既是好消息又是坏消息.DataFlux的副总裁Jill Dyché在最近召开的数据治理会议上告诉我们,高度可视化的数据正在吸引商业领袖的眼球. D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZo13p.html" rel="bookmark" class="title">阿里巴巴、Facebook、Cloudera等巨头的数据收集框架全攻略</a>
					<div>
						互联网的发展,带来了日新月异的业务种类,随着业务的增长,随之而来的,是业务日志指数的递增.一些公司每条业务线, 提供服务的线上服务器就达几百台之多, 每天的日志量超百亿.如何能够将散落在各服务器上的日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBnyNM.html" rel="bookmark" class="title">保底代刷百度主题有危险 个人站长须谨慎</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 3月18日消息,接站长站网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQAxmp.html" rel="bookmark" class="title">listview-Android中的 Scroll ListView 和 TextView</a>
					<div>
						问题描述 Android中的 Scroll ListView 和 TextView 我想创建一个布局包含: textview(标题) listview 就是说当用户上下滑动滚动条的时候,希望整个画面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqQ77p.html" rel="bookmark" class="title">大数据引爆共享经济 成重要支撑</a>
					<div>
						本文首发于微信公众号:数据猿.文章内容属作者个人观点,不代表和讯网立场.投资者据此操作,风险请自担. 根据不完全统计,2016年第二季度,中国大数据企业共计发生34起投融资事件,相比上个季度环比增长7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvngQ1M.html" rel="bookmark" class="title">借助大数据培育健康医疗产业群</a>
					<div>
						位于顺德乐从的广东省健康医疗大数据产业园昨日开园,将致力打造医学大数据产业生态圈 昨日,广东省健康医疗大数据产业园正式开园,一个以健康医疗为&quot;引爆点&quot;的大数据创新创业高地正在顺德北 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8qOdp.html" rel="bookmark" class="title">php不用正则采集速度探究总结&lowbar;php技巧</a>
					<div>
						 注意:下面的所有函数都没有用正则. 以上为取出第一个匹配的三个函数,实现相同的目的 复制代码 代码如下: function str_cut($str ,$start, $end) {//取出第一个匹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5QyRz.html" rel="bookmark" class="title">jQuery中多个元素的Hover事件解决方案&lowbar;jquery</a>
					<div>
						1.需求简介 jQuery的hover事件只是针对单个HTML元素,例如: 复制代码 代码如下: $('#login').hover(fun2, fun2); 当鼠标进入#login元素时调用fun1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKQjvM.html" rel="bookmark" class="title">ASP访问Exchange Server问题</a>
					<div>
						&lt;% Response.Status = (&quot;401 Unauthorized&quot;) bstrServer = &quot;SERVER2&quot; Dim objSessi ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
